#!/usr/bin/env python
# -*- coding: utf-8 -*-

from gimpfu import *
import os, glob

def do_load_files(imgfname) :
    img = pdb.gimp_file_load(imgfname + "_R.tif", "")
#                             load R ch. file as background
    img.filename = imgfname  + "_RGB.xcf" #change image's filename
    disp = pdb.gimp_display_new(img) #display image
    filenames = [imgfname + "_Periphery_Adjst_Mask.tif",
       imgfname + "_Binary_Mask.tif",
       imgfname + "_R+128.tif",
       imgfname + "_B.tif",
       imgfname + "_B_foreground.tif",
       imgfname + "_B_Background.tif",
       imgfname + "_G+R.tif",
       imgfname + "_Dark.tif",
       imgfname + "_G.tif", imgfname + "_R.tif"]
    for filename in filenames:
        try:
            image_id, layer_ids = pdb.gimp_file_load_layers(img,
                 filename)
            for id in layer_ids:
                new_layer = gimp.Item.from_id(id)
                pdb.gimp_image_add_layer(img, new_layer, 0)
                pdb.gimp_layer_add_alpha (new_layer)
                if filename == filenames[4] or filename == filenames[5]  or filename == filenames[6]:
                    mask = pdb.gimp_layer_create_mask(new_layer, ADD_WHITE_MASK)
                    pdb.gimp_layer_add_mask(new_layer, mask)
        except Exception, error:
            print error
    image = gimp.image_list()[0]
#
    pdb.gimp_edit_copy(image.layers[7]) # Copy Mask Image Layer
    pdb.gimp_layer_set_edit_mask(image.layers[5], TRUE) # Activate Mask Edit Mode
    floating_sel = pdb.gimp_edit_paste(image.layers[5].mask, False) # Paste Mask Image as Mask
    pdb.gimp_floating_sel_anchor(floating_sel) # Paste Layer Fixed
#
    pdb.gimp_edit_copy(image.layers[8])
    pdb.gimp_layer_set_edit_mask(image.layers[4], TRUE)
    floating_sel = pdb.gimp_edit_paste(image.layers[4].mask, False)
    pdb.gimp_floating_sel_anchor(floating_sel)
#
    pdb.gimp_edit_copy(image.layers[9])
    pdb.gimp_layer_set_edit_mask(image.layers[3], TRUE)
    floating_sel = pdb.gimp_edit_paste(image.layers[3].mask, False)
    pdb.gimp_floating_sel_anchor(floating_sel)
# Back Ground Layer (image.layers[10]) to White
    color = (1.0, 1.0, 1.0, 1.0)
#    color: (R Value, G Value, B Value, Transparence)
    pdb.gimp_context_set_background(color) #Set background painting color
    pdb.gimp_edit_fill(image.layers[10], BACKGROUND_FILL)
#    Fill layer[10] with Background Painting Color
#
    return

register(
    "do_load_files_v2j",
    "黄変写真補正素材ファイル読込",
    "Load files for Photo Color adjustment",
    "Ohnishi, Yasuo",
    "Ohnishi, Yasuo",
    "2021 Ver2.01",
    "ファイル読込...",
    "",      # Alternately use RGB, RGB*, GRAY*, INDEXED etc.
    [
        (PF_FILE, "imgfname", "作成元黄変写真ファイルの指定", ""),
    ],
    [],
    do_load_files, menu="<Image>/My Plugins/黄変写真補正ツール Ver2" )
main()

